commit:     f4662bc9b410044c7f4a2118efb479b1523d591f
Author:     Pascal Jäger <pascal.jaeger <AT> leimstift <DOT> de>
AuthorDate: Thu Dec 15 11:25:01 2022 +0000
Commit:     Sebastian Pipping <sping <AT> gentoo <DOT> org>
CommitDate: Fri Dec 16 20:18:44 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=f4662bc9

x11-misc/xscreensaver: revbump, fix bugs

Closes: https://bugs.gentoo.org/885441
Closes: https://bugs.gentoo.org/885479
Closes: https://bugs.gentoo.org/885989
Closes: https://github.com/gentoo/gentoo/pull/28671

Signed-off-by: Pascal Jäger <pascal.jaeger <AT> leimstift.de>
Signed-off-by: Sebastian Pipping <sping <AT> gentoo.org>

 ...xscreensaver-6.05-r2-configure-exit-codes.patch |  43 ++++
 x11-misc/xscreensaver/xscreensaver-6.05-r2.ebuild  | 248 +++++++++++++++++++++
 2 files changed, 291 insertions(+)

diff --git 
a/x11-misc/xscreensaver/files/xscreensaver-6.05-r2-configure-exit-codes.patch 
b/x11-misc/xscreensaver/files/xscreensaver-6.05-r2-configure-exit-codes.patch
new file mode 100644
index 000000000000..d69e5965ca2f
--- /dev/null
+++ 
b/x11-misc/xscreensaver/files/xscreensaver-6.05-r2-configure-exit-codes.patch
@@ -0,0 +1,43 @@
+The configure scripts exits on a non zero exit code even with a warning. Even
+though for upstream this is just a warning, for portage this means failure and
+it will exit.
+We therefore alter the exit codes where neccesary.
+
+Bug: https://bugs.gentoo.org/885441
+
+Pascal Jäger <[email protected]> (2022-12-15)
+
+--- a/configure.ac
++++ b/configure.ac
+@@ -4588,7 +4588,6 @@ if test "$have_motif" = no -a "$have_gtk" = no; then
+   else
+     warnL "The GTK libraries do not seem to be available; the"
+     warn2 "\`xscreensaver-settings' program requires them."
+-    CONF_STATUS=1
+ #   echo ''
+ #   warn2 'You can use Motif or Lesstif instead of GTK (use the'
+ #   warn2 "\`--with-motif' option) but that is NOT recommended."
+@@ -4615,7 +4614,6 @@ if test "$have_gtk" = yes -a "$have_gdk_pixbuf" = no ; 
then
+   warn  "GTK is being used, but the GDK-Pixbuf library and/or"
+   warn2 "headers were not found.  That can't be good.  Please"
+   warn2 "install the GDK-Pixbuf development kit and re-configure."
+-  CONF_STATUS=1
+ fi
+ 
+ if test "$have_motif" = yes -a "$have_lesstif" = yes ; then
+@@ -4714,7 +4712,6 @@ if test "$have_jpeg" = no ; then
+     warn2 "This means that it won't be possible for the image-manipulating"
+     warn2 "display modes to load files from disk; and it also means that"
+     warn2 "the \`webcollage' program will be much slower."
+-    CONF_STATUS=1
+   else
+     warn2 "This means the \`webcollage' program will be much slower."
+   fi
+@@ -4733,7 +4730,6 @@ if test "$have_png" = no ; then
+ 
+   if test "$png_halfassed" = yes ; then halfassery ; fi
+   warn2 "Many things aren't going to work right."
+-  CONF_STATUS=1
+ fi
+ 
+ 

diff --git a/x11-misc/xscreensaver/xscreensaver-6.05-r2.ebuild 
b/x11-misc/xscreensaver/xscreensaver-6.05-r2.ebuild
new file mode 100644
index 000000000000..a8c07d03c410
--- /dev/null
+++ b/x11-misc/xscreensaver/xscreensaver-6.05-r2.ebuild
@@ -0,0 +1,248 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+inherit autotools flag-o-matic font optfeature pam strip-linguas
+
+DESCRIPTION="Modular screen saver and locker for the X Window System"
+HOMEPAGE="https://www.jwz.org/xscreensaver/";
+SRC_URI="https://www.jwz.org/xscreensaver/${P}.1.tar.gz";
+
+# Font license mapping for folder ./hacks/fonts/ as following:
+#   clacon.ttf       -- MIT
+#   gallant12x22.ttf -- unclear, hence dropped
+#   luximr.ttf       -- bh-luxi (package media-fonts/font-bh-ttf)
+#   OCRAStd.otf      -- unclear, hence dropped
+#   SpecialElite.ttf -- Apache-2.0
+LICENSE="BSD fonts? ( MIT Apache-2.0 )"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~loong ~mips ~ppc ~ppc64 
~riscv ~sparc ~x86 ~amd64-linux ~x86-linux"
+IUSE="elogind fonts +gdk-pixbuf gdm gles glx +gtk jpeg +locking new-login 
offensive pam +perl +png selinux suid systemd xinerama"
+REQUIRED_USE="
+       gles? ( !glx )
+       ?? ( elogind systemd )
+       gtk? ( gdk-pixbuf )
+       pam? ( locking )
+"
+
+COMMON_DEPEND="
+       >=dev-libs/libxml2-2.4.6
+       x11-apps/appres
+       x11-apps/xwininfo
+       x11-libs/libX11
+       x11-libs/libXext
+       x11-libs/libXi
+       x11-libs/libXrandr
+       x11-libs/libXt
+       x11-libs/libXxf86vm
+       elogind? ( sys-auth/elogind )
+       gdk-pixbuf? (
+               x11-libs/gdk-pixbuf-xlib
+               >=x11-libs/gdk-pixbuf-2.42.0:2
+       )
+       gtk? ( >=x11-libs/gtk+-2.22.0:3 )
+       jpeg? ( media-libs/libjpeg-turbo:= )
+       locking? ( virtual/libcrypt:= )
+       new-login? (
+               gdm? ( gnome-base/gdm )
+               !gdm? ( || ( x11-misc/lightdm lxde-base/lxdm ) )
+       )
+       virtual/glu
+       virtual/opengl
+       pam? ( sys-libs/pam )
+       png? ( media-libs/libpng:= )
+       systemd? ( >=sys-apps/systemd-221 )
+       >=x11-libs/libXft-2.1.0
+       xinerama? ( x11-libs/libXinerama )
+"
+# For USE="perl" see output of `qlist xscreensaver | grep bin | xargs grep 
'::'`
+RDEPEND="
+       ${COMMON_DEPEND}
+       media-gfx/fbida
+       perl? (
+               dev-lang/perl
+               dev-perl/libwww-perl
+               virtual/perl-Digest-MD5
+       )
+       selinux? ( sec-policy/selinux-xscreensaver )
+"
+DEPEND="
+       ${COMMON_DEPEND}
+       x11-base/xorg-proto
+"
+BDEPEND="
+       dev-util/intltool
+       sys-devel/bc
+       sys-devel/gettext
+       virtual/pkgconfig
+"
+PATCHES=(
+       "${FILESDIR}"/${PN}-6.01-interix.patch
+       "${FILESDIR}"/${PN}-5.31-pragma.patch
+       "${FILESDIR}"/${PN}-6.01-gentoo.patch
+       "${FILESDIR}"/${PN}-5.45-gcc.patch
+       "${FILESDIR}"/${PN}-6.01-configure.ac-sandbox.patch
+       "${FILESDIR}"/${PN}-6.01-without-gl-makefile.patch
+       "${FILESDIR}"/${PN}-6.01-non-gtk-install.patch
+       "${FILESDIR}"/${PN}-6.01-configure-install_sh.patch
+       "${FILESDIR}"/${PN}-6.03-without-gl-configure.patch
+       "${FILESDIR}"/${PN}-6.05-remove-update-icon-cache.patch
+       "${FILESDIR}"/${PN}-6.05-r2-configure-exit-codes.patch
+       "${FILESDIR}"/${PN}-6.05-get-dirs-from-gtk3.0-in-configure.patch
+)
+
+DOCS=( README{,.hacking} )
+
+src_prepare() {
+       default
+
+       sed -i configure.ac -e '/^ALL_LINGUAS=/d' || die
+       strip-linguas -i po/
+       export ALL_LINGUAS="${LINGUAS}"
+
+       if use new-login && ! use gdm; then #392967
+               sed -i \
+                       -e "/default_l.*1/s:gdmflexiserver 
-ls:${EPREFIX}/usr/libexec/lightdm/&:" \
+                       configure{,.ac} || die
+       fi
+
+       # We are patching driver/XScreenSaver.ad.in, so let's delete the
+       # header generated from it so that it gets back in sync during build:
+       rm driver/XScreenSaver_ad.h || die
+
+       if ! use offensive; then
+               sed -i \
+                       -e 
'/boobies/d;/boobs/d;/cock/d;/pussy/d;/viagra/d;/vibrator/d' \
+                       hacks/barcode.c || die
+               sed -i \
+                       -e 's|erect penis|shuffle board|g' \
+                       -e 's|flaccid penis|flaccid anchor|g' \
+                       -e 's|vagina|engagement ring|g' \
+                       -e 's|Penis|Shuttle|g' \
+                       hacks/glx/glsnake.c || die
+               sed -i \
+                       's| Stay.*fucking mask\.$||' \
+                       hacks/glx/covid19.man \
+                       hacks/config/covid19.xml || die
+               eapply 
"${FILESDIR}/xscreensaver-6.05-teach-handsy-some-manners.patch"
+       fi
+
+       config_rpath_update "${S}"/config.rpath
+
+       # Must be eauto*re*conf, to force the rebuild
+       eautoreconf
+}
+
+src_configure() {
+       if use ppc || use ppc64; then
+               filter-flags -maltivec -mabi=altivec
+               append-flags -U__VEC__
+       fi
+
+       unset BC_ENV_ARGS #24568
+
+       # /proc/interrupts won't always have the keyboard bits needed
+       # Not clear this does anything in 6.03+(?) but let's keep it for now in 
case.
+       # (See also: configure argument)
+       export ac_cv_have_proc_interrupts=yes
+
+       # WARNING: This is NOT a normal autoconf script
+       # Some of the --with options are NOT standard, and expect "--with-X=no" 
rather than "--without-X"
+       ECONF_OPTS=(
+               $(use_enable locking)
+               $(use_with elogind)
+               $(use_with gdk-pixbuf pixbuf)
+               $(use_with gles)
+               $(use_with glx)
+               $(use_with gtk)
+               $(use_with new-login login-manager)
+               $(use_with pam)
+               $(use_with suid setuid-hacks)
+               $(use_with systemd)
+               $(use_with xinerama xinerama-ext)
+               --with-jpeg=$(usex jpeg yes no)
+               --with-png=$(usex png yes no)
+               --with-xft=yes
+               --with-app-defaults="${EPREFIX}"/usr/share/X11/app-defaults
+               --with-configdir="${EPREFIX}"/usr/share/${PN}/config
+               --with-dpms-ext
+               --with-hackdir="${EPREFIX}"/usr/$(get_libdir)/misc/${PN}
+               --with-proc-interrupts
+               --with-randr-ext
+               --with-text-file="${EPREFIX}"/etc/gentoo-release
+               --with-xdbe-ext
+               --with-xf86gamma-ext
+               --with-xf86vmode-ext
+               --with-xinput-ext
+               --with-xkb-ext
+               --with-xshm-ext
+               --without-gle
+               --without-kerberos
+               --without-motif
+               --with-proc-oom
+               --x-includes="${EPREFIX}"/usr/include
+               --x-libraries="${EPREFIX}"/usr/$(get_libdir)
+       )
+       # WARNING: This is NOT a normal autoconf script
+       econf "${ECONF_OPTS[@]}"
+}
+
+src_compile() {
+       # stock target is "default", which is broken in some releases.
+       emake all
+}
+
+src_install() {
+       use pam && dodir /etc/pam.d/
+       emake install_prefix="${D}" DESTDIR="${D}" 
GTK_SHAREDIR="${installprefix}"/usr/share/xscreensaver install
+
+       if use fonts; then
+               # Do not install fonts with unclear licensing
+               rm -v "${ED}${FONTDIR}"/{gallant12x22.ttf,OCRAStd.otf} || die
+
+               # Do not duplicate font Luxi Mono (of package 
media-fonts/font-bh-ttf)
+               rm -v "${ED}${FONTDIR}"/luximr.ttf || die
+
+               font_xfont_config
+       else
+               rm -v "${ED}${FONTDIR}"/*.{ttf,otf} || die
+               rmdir -v "${ED}${FONTDIR}" || die #812473
+       fi
+
+       einstalldocs
+
+       if use pam; then
+               fperms 755 /usr/bin/${PN}
+               pamd_mimic_system ${PN} auth
+       fi
+
+       # bugs #809599, #828869
+       if ! use gtk; then
+               rm "${ED}/usr/bin/xscreensaver-demo" || die
+       fi
+       # Makefile installs xscreensaver.service regardless of --without-systemd
+       if ! use systemd; then
+               rm "${ED}/usr/share/${PN}/xscreensaver.service" || die
+       fi
+
+       # bug #885989
+       fperms 4755 /usr/$(get_libdir)/misc/xscreensaver/xscreensaver-auth
+}
+
+pkg_postinst() {
+       use fonts && font_pkg_postinst
+
+       # bug #811885
+       if ! use glx; then
+               elog "Enable USE='glx' if OpenGL screensavers are crashing."
+       fi
+
+       optfeature 'Bitmap fonts 75dpi' media-fonts/font-adobe-75dpi
+       optfeature 'Bitmap fonts 100dpi' media-fonts/font-adobe-100dpi
+       optfeature 'Truetype font Luxi Mono' media-fonts/font-bh-ttf
+}
+
+pkg_postrm() {
+       use fonts && font_pkg_postrm
+}

Reply via email to